import { Injectable } from "@angular/core";
import { XHRBackend, ResponseOptions, XSRFStrategy } from "@angular/http";
import { ProgressBrowserXhrFactory } from "./ProgressBrowserXhrFactory";
var XHRBackendFactory = (function () {
    function XHRBackendFactory(responseOptions, xsrfStrategy, progressBrowserXhrFactory) {
        this.responseOptions = responseOptions;
        this.xsrfStrategy = xsrfStrategy;
        this.progressBrowserXhrFactory = progressBrowserXhrFactory;
    }
    XHRBackendFactory.prototype.create = function (upload, download) {
        var progressBrowserXhr = this.progressBrowserXhrFactory.create(upload, download);
        return new XHRBackend(progressBrowserXhr, this.responseOptions, this.xsrfStrategy);
    };
    XHRBackendFactory.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    XHRBackendFactory.ctorParameters = function () { return [
        { type: ResponseOptions, },
        { type: XSRFStrategy, },
        { type: ProgressBrowserXhrFactory, },
    ]; };
    return XHRBackendFactory;
}());
export { XHRBackendFactory };
//# sourceMappingURL=XHRBackendFactory.js.map