var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Injectable, Inject } from "@angular/core";
import { Http, RequestOptions, ConnectionBackend } from "@angular/http";
import { XHRBackendFactory } from "./XHRBackendFactory";
import { HTTP_FACTORY } from "./http-factory.token";
var ProgressHttp = (function (_super) {
    __extends(ProgressHttp, _super);
    function ProgressHttp(xhrBackendFactory, requestOptions, httpFactory, backend) {
        var _this = _super.call(this, null, requestOptions) || this;
        _this.xhrBackendFactory = xhrBackendFactory;
        _this.requestOptions = requestOptions;
        _this.httpFactory = httpFactory;
        _this._uploadCallback = null;
        _this._downloadCallback = null;
        _this.http = httpFactory.create(backend, requestOptions);
        return _this;
    }
    ProgressHttp.prototype.request = function (url, options) {
        return this.http.request(url, options);
    };
    ProgressHttp.prototype.withDownloadProgressListener = function (listener) {
        this._downloadCallback = listener;
        return this._buildProgressHttpInstance();
    };
    ProgressHttp.prototype.withUploadProgressListener = function (listener) {
        this._uploadCallback = listener;
        return this._buildProgressHttpInstance();
    };
    ProgressHttp.prototype._buildProgressHttpInstance = function () {
        var progressHttp = new ProgressHttp(this.xhrBackendFactory, this.requestOptions, this.httpFactory, this._buildXHRBackend());
        progressHttp._uploadCallback = this._uploadCallback;
        progressHttp._downloadCallback = this._downloadCallback;
        return progressHttp;
    };
    ProgressHttp.prototype._buildXHRBackend = function () {
        var backend = this.xhrBackendFactory.create(this._uploadCallback, this._downloadCallback);
        return backend;
    };
    ProgressHttp.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    ProgressHttp.ctorParameters = function () { return [
        { type: XHRBackendFactory, },
        { type: RequestOptions, },
        { type: undefined, decorators: [{ type: Inject, args: [HTTP_FACTORY,] },] },
        { type: ConnectionBackend, },
    ]; };
    return ProgressHttp;
}(Http));
export { ProgressHttp };
//# sourceMappingURL=progress-http.service.js.map